﻿using MHoApps.SnippsCode.ViewModel.Services;
using System.Threading;
using System.Windows;

namespace MHoApps.SnippsCode.Services
{
    /// <summary>
    /// 
    /// </summary>
    public class MessageBoxService : IMessageBoxService
    {
        public MessageBoxResultEnum Show(string message, string title, MessageBoxButtonEnum buttons = MessageBoxButtonEnum.OK, MessageBoxImageEnum image = MessageBoxImageEnum.None)
        {
            Thread.CurrentThread.TrySetApartmentState(ApartmentState.STA);
            IWaitingCursorService wcServ = ServiceContainer.GetService<IWaitingCursorService>();
            wcServ.SetWaitingCursor(false);
            MessageBoxResult msgBoxResult = Application.Current.Dispatcher.Invoke(() => MessageBox.Show(message, title, (MessageBoxButton)buttons, (MessageBoxImage)image));

            return (MessageBoxResultEnum)msgBoxResult;

        }
    }
}
