﻿using ICSharpCode.AvalonEdit;
using System;
using System.Windows;

namespace MHoApps.SnippsCode.View.AttachedProperties
{
    /// <summary>
    /// 
    /// </summary>
    public class AvalonBindingHelper : DependencyObject
    {
        #region TextBining
        public static string GetAvalonText(DependencyObject element)
        {
            if (element == null)
                throw new ArgumentNullException("element");

            return Convert.ToString(element.GetValue(AvalonTextProperty));
        }

        public static void SetAvalonText(DependencyObject element, string value)
        {
            if (element == null)
                throw new ArgumentNullException("element");

            element.SetValue(AvalonTextProperty, value);
        }

        public static readonly DependencyProperty AvalonTextProperty = DependencyProperty.RegisterAttached("AvalonText", typeof(string), typeof(AvalonBindingHelper), new PropertyMetadata(null, AvalonTextProprty_Changed));

        private static void AvalonTextProprty_Changed(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            TextEditor textEditor = (TextEditor)d;
            textEditor.TextChanged -= AvalonText_Changed;
            textEditor.TextChanged += AvalonText_Changed;
            textEditor.Document.Text = e.NewValue as string;
        }
        private static void AvalonText_Changed(object sender, EventArgs e)
        {
            var av = (TextEditor)sender;

            av.SetValue(AvalonTextProperty, av.Document.Text);
        }
        #endregion


    }
}
