﻿using System;
using System.Collections.Generic;

namespace MHoApps.SnippsCode.ViewModel.Services
{
    /// <summary>
    /// 
    /// </summary>
    public class ServiceContainer
    {
        public static readonly ServiceContainer Instance = new ServiceContainer();

        #region Constructor

        /// <summary>
        /// default constructor
        /// </summary>
        static ServiceContainer()
        {
            ServiceMap = new Dictionary<Type, object>();
            ServiceMapLock = new object();
        }

        #endregion

        public void AddService<TServiceContract>(TServiceContract implementation) where TServiceContract : class
        {
            lock (ServiceMapLock)
                ServiceMap[typeof(TServiceContract)] = implementation;
        }

        public static TServiceContract GetService<TServiceContract>() where TServiceContract : class
        {
            object service = null;
            lock (ServiceMapLock)
                ServiceMap.TryGetValue(typeof(TServiceContract), out service);
            return service as TServiceContract;
        }


        static readonly Dictionary<Type, object> ServiceMap;

        static readonly object ServiceMapLock;
    }
}
