﻿using System.Collections.ObjectModel;
using System.IO;
using System.Windows.Input;

namespace MHoApps.SnippsCode.ViewModel
{
    /// <summary>
    /// 
    /// </summary>
    public class TabItemViewModel : Base.ViewModelBase
    {
        private ObservableCollection<TabItemViewModel> _tabItems;
        #region Constructor

        /// <summary>
        /// default constructor
        /// </summary>
        public TabItemViewModel(string header, string tag, ObservableCollection<TabItemViewModel> tabItems, EditorViewModel editor)
        {
            CloseCommand = new Base.RelayCommand(t => CloseTab());
            Header = header;
            Tag = tag;
            _tabItems = tabItems;
            CodeEditor = editor;
            if (IsInDesignMode)
            {
                Header = "TestTab";
            }
        }

        #endregion

        public string Header { get; set; }

        public string Tag { get; set; }

        public EditorViewModel CodeEditor { get; set; }

        public ICommand CloseCommand { get; set; }

        private void CloseTab()
        {
            _tabItems.Remove(this);
        }
    }
}
